/*
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   - 
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   - 
   - The Original Code is Mozilla Communicator client code.
   - 
   - The Initial Developer of the Original Code is Daniel Brooks.  
   - Portions created by Netscape are Copyright (C) 2001 Daniel
   - Brooks.  All Rights Reserved.
   - 
   - Contributor(s):  Daniel Brooks <db48x@yahoo.com>
   - 
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable 
   - instead of those above.  If you wish to allow use of your 
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
*/


const nsICacheService = Components.interfaces.nsICacheService;
var cacheservice = Components.classes["@mozilla.org/network/cache-service;1"].getService(nsICacheService);
var httpcachesession = cacheservice.createSession("HTTP", 0, true);
var ftpcachesession = cacheservice.createSession("FTP", 0, true);

function makePreview()
{
 // a few things I'll need
  const nsIStandardURL = Components.interfaces.nsIStandardURL;       
  const nsIMIMEService = Components.interfaces.nsIMIMEService;
  const nsINetDataCacheManager = Components.interfaces.nsINetDataCacheManager;
  const stdURL = Components.classes["@mozilla.org/network/standard-url;1"];

  thebundle = document.getElementById("pageinfobundle");

  var url = window.parent.document.getElementById("imagepreview").getAttribute("url");
  document.getElementById("urltext").setAttribute("value", url);

 // find out the mime type
  var pageURL = stdURL.createInstance(nsIStandardURL);
  pageURL.init(nsIStandardURL.URLTYPE_STANDARD, 80, url, null);// I will need to find out what the 80 is, just in case
  var mimeservice = Components.classes["@mozilla.org/mime;1"].getService(nsIMIMEService);
  try 
  {
    var mimetype = mimeservice.GetTypeFromURI(pageURL);
  } 
  catch(ex) 
  {
    var mimetype = thebundle.getString("unknown");
  }
  document.getElementById("typetext").setAttribute("value", mimetype);

  var modifiedtext = thebundle.getString("unknown");
//  modifiedtext = page.lastModified;     // have to change this, we don't have a page, we have a url to an image (and probably a chache entry for it)
  document.getElementById("modifiedtext").setAttribute("value", modifiedtext);

 // get cache info
  var sourcetext = thebundle.getString("generalNotCached");
  var expirationtext = thebundle.getString("unknown");
  var sizetext = thebundle.getString("unknown");

  try
  {
    var cacheentrydescriptor = httpcachesession.openCacheEntry(url, 1);   // open for READ
    if (cacheentrydescriptor)
    {
      switch(cacheentrydescriptor.deviceID)
      {
        case "disk":
          sourcetext = thebundle.getString("generalDiskCache");
          break;
        case "memory":
          sourcetext = thebundle.getString("generalMemoryCache");
          break;
        default:
          sourcetext = cacheentrydescriptor.deviceID;
          break;
      }

      sizetext = cacheentrydescriptor.dataSize;

      var expirationtime = cacheentrydescriptor.expirationTime;
      expirationtext = new Date(expirationtime*1000).toString();
    }
  }
  catch(ex)
  {
    try
    {
      cacheentrydescriptor = ftpcachesession.openCacheEntry(url, 1);   // open for READ
      if (cacheentrydescriptor)
      {
        switch(cacheentrydescriptor.deviceID)
        {
          case "disk":
            sourcetext = thebundle.getString("generalDiskCache");
            break;
          case "memory":
            sourcetext = thebundle.getString("generalMemoryCache");
            break;
          default:
            sourcetext = cacheentrydescriptor.deviceID;
            break;
        }

        sizetext = cacheentrydescriptor.dataSize;

        var expirationtime = cacheentrydescriptor.expirationTime;
        expirationtext = new Date(expirationtime*1000).toString();
      }
    }
    catch(ex2)
    {
      sourcetext = thebundle.getString("unknown");
    }
  }
  document.getElementById("sourcetext").setAttribute("value", sourcetext);
    document.getElementById("expirestext").setAttribute("value", expirationtext);
  document.getElementById("sizetext").setAttribute("value", sizetext);

  document.getElementById("theimagecontainer").appendChild(image = document.createElement("image"));
  image.setAttribute("src", url);
}