/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s): smorrison@gte.com
 *   Terry Hayes <thayes@netscape.com>
 *   Daniel Brooks <db48x@yahoo.com>
*/

// mmm, yummy. global variables.
var thecontent = null;

var linktreechildren = document.getElementById("linktreechildren");
var formtreechildren = document.getElementById("formtreechildren");
var imagetreechildren = document.getElementById("imagetreechildren");
//var frametreechildren = document.getElementById("frametreechildren");

var linklist = new Array();
var formlist = new Array();
var imagelist = new Array();

var linkindex = 0;
var formindex = 0;
var imageindex = 0;
var framecount = 0;

const nsICacheService = Components.interfaces.nsICacheService;
var cacheservice = Components.classes["@mozilla.org/network/cache-service;1"].getService(nsICacheService);
var httpcachesession = cacheservice.createSession("HTTP", 0, true);
var ftpcachesession = cacheservice.createSession("FTP", 0, true);

/* Overlays register init functions here */
var onLoadRegistry = [ ];
 
function onLoadPageInfo()
{
  dump("Page Info - Begin: "+window.opener._content.location+"\n");

  thebundle = document.getElementById("pageinfobundle");

  if ((window.arguments.length >= 1) && window.arguments[0])
    page = window.arguments[0];
  else
  {
    thecontent = window.opener._content;
    page = window.opener.frames[0].document;
  }

  // do the easy stuff first
  makeGeneralTab();

  /* Call registered overlay init functions */
  for (x in onLoadRegistry)
  {
    onLoadRegistry[x]();
  }

  /* Selected the requested tab, if the name is specified */
  /*  if (window.arguments != null) { */
  if ("arguments" in window) {
    var tabName = window.arguments[0];

    if (tabName)
    {
      var tabControl = document.getElementById("tabcontrol");
      var tab = document.getElementById(tabName);

      if (tabControl && tab) {
        tabControl.selectedTab = tab;
      }
    }
  }
}

function makeGeneralTab()
{
 // some standard interfaces that'll be used later
  const nsIStandardURL = Components.interfaces.nsIStandardURL;       
  const nsIMIMEService = Components.interfaces.nsIMIMEService;
  const nsINetDataCacheManager = Components.interfaces.nsINetDataCacheManager;
  const stdURL = Components.classes["@mozilla.org/network/standard-url;1"];
  
  var page = thecontent.document;  
  
  var title = page.title || thebundle.getString("noPageTitle");
  document.getElementById("titletext").setAttribute("value", title+":");

  var url   = page.location;
  document.getElementById("urltext").setAttribute("value", url);

 // find out the mime type
  var pageURL = stdURL.createInstance(nsIStandardURL);
  pageURL.init(nsIStandardURL.URLTYPE_STANDARD, 80, url, null); // I will need to find out what the 80 is, just in case
  var mimeservice = Components.classes["@mozilla.org/mime;1"].getService(nsIMIMEService);
  try 
  {
    var mimetype = mimeservice.GetTypeFromURI(pageURL);
  } 
  catch(ex) 
  {
    var mimetype = thebundle.getString("unknown");
  }
  document.getElementById("typetext").setAttribute("value", mimetype);
  
 // get the meta tags
  var metanodes = page.getElementsByTagName("meta");
  var metatreechildren = document.getElementById("metatreechildren");

  for (var i = 0; i < metanodes.length; i++)
  {
    var treeitem = document.createElement("treeitem");
    var treerow = treeitem.appendChild(document.createElement("treerow"));

    var treecell = treerow.appendChild(document.createElement("treecell"));
    treecell.setAttribute("label", metanodes[i].name || metanodes[i].http-equiv);

    var treecell = treerow.appendChild(document.createElement("treecell"));
//    var htmlnode = treecell.appendChild(document.createElement("html"));
//    htmlnode.appendChild(document.createTextNode(metanodes[i].content));
    treecell.setAttribute("label", metanodes[i].content);

    metatreechildren.appendChild(treeitem);
  }  
  
 // get the document characterset
  var encoding = page.characterSet;
  document.getElementById("encodingtext").setAttribute("value", encoding);

  modifiedtext = page.lastModified || thebundle.getString("unknown");
  document.getElementById("modifiedtext").setAttribute("value", modifiedtext);
  
 // get cache info
  var sourcetext = thebundle.getString("generalNotCached");
  var expirationtext = thebundle.getString("unknown");

  var sizetext = thebundle.getString("unknown");

  try
  {
    var cacheentrydescriptor = httpcachesession.openCacheEntry(url, 1);   // open for READ
    if(cacheentrydescriptor)
    { 
      switch(cacheentrydescriptor.deviceID)
      {
        case "disk":
          sourcetext = thebundle.getString("generalDiskCache");
          break;
        case "memory":
          sourcetext = thebundle.getString("generalMemoryCache");
          break;
        default:
          sourcetext = cacheentrydescriptor.deviceID;
          break;
      }

      sizetext = cacheentrydescriptor.dataSize;

      var expirationtime = cacheentrydescriptor.expirationTime;
      expirationtext = new Date(expirationtime*1000).toString();
    }
  }
  catch(ex)
  {
    try
    {
      cacheentrydescriptor = ftpcachesession.openCacheEntry(url, 1);   // open for READ
      if (cacheentrydescriptor)
      {
        switch(cacheentrydescriptor.deviceID)
        {
          case "disk":
            sourcetext = thebundle.getString("generalDiskCache");
            break;
          case "memory":
            sourcetext = thebundle.getString("generalMemoryCache");
            break;
          default:
            sourcetext = cacheentrydescriptor.deviceID;
            break;
        }

        sizetext = cacheentrydescriptor.dataSize;

        var expirationtime = cacheentrydescriptor.expirationTime;
        expirationtext = new Date(expirationtime*1000).toString();
      }
    }
    catch(ex2)
    {
      sourcetext = thebundle.getString("unknown");
    }
  }
  document.getElementById("sourcetext").setAttribute("value", sourcetext);
  document.getElementById("expirestext").setAttribute("value", expirationtext);
  document.getElementById("sizetext").setAttribute("value", sizetext);

  // this doesn't seem to be working. was worth a try at any rate. this is bug 76099
  var referer = window.opener.referer;
  if (referer)
  {
    var referertext = referer.location;
  }
  else
  {
    var referertext = thebundle.getString("unknown");
  }
  document.getElementById("referertext").setAttribute("value", referertext);
}

//******** Form Stuff
function makeFormTab()
{
  var start = new Date();
  var formindex = 0;
  var formtreechildren = document.getElementById("formtreechildren");
  
  if(formtreechildren.firstChild)
  {
    dump("Page Info - Form Tab already filled in, skipping.\n");
    return;
  }

  formlist = grabAllForms(thecontent);

  if (formlist.length > 0)
  {
    for (var i = 0; i < formlist.length; i++)
    {
      var elem = formlist[i];
      makeARow(formtreechildren, [++formindex, elem.name, elem.method, elem.action]);
    }
  }
  
  var end = new Date();
  dump("Page Info - Form Tab Construction - Rows Created: "+formlist.length+", Elapsed Time: "+(end - start)+"ms\n");
}

function grabAllForms(thecontent)
{
  if (thecontent.frames.length > 0)
  {
    var thelist = [];
    for (var i = 0; i < thecontent.frames.length; i++)
    {
      concatAA(thelist, grabAllForms(thecontent.frames[i]));
    }
  }
  else
  {
    thelist = thecontent.document.forms;
  }
  
  return thelist;
}

function onFormSelect()
{
  var tree = document.getElementById("formtree");
  var preview = document.getElementById("formpreviewtree");

  if (tree.selectedItems.length == 1)
  {
    var clickedRow = tree.selectedItems[0].firstChild;
    var firstCell = clickedRow.firstChild;
    var formnum = firstCell.getAttribute("label");
    var form = formlist[formnum-1];
//    var form = firstCell.getAttribute("label");

var ftp=thebundle.getString("formTitlePrefix");
var fts=thebundle.getString("formTitleSuffix");
dump("Moo!\n");
    document.getElementById("formname").setAttribute("value", (ftp + " " + form.name + fts) || thebundle.getString("formUntitled"));
    document.getElementById("formenctype").setAttribute("value", form.encoding || thebundle.getString("unknown"));
    document.getElementById("formtarget").setAttribute("value", form.target || thebundle.getString("unknown"));

    var treechildren = document.getElementById("formpreviewchildren");
    while (treechildren.hasChildNodes()) treechildren.removeChild(treechildren.firstChild);

    var formelements = form.elements;
    
    var array = new Array(formelements.length);
    var index = 0;
    
    for (var i = 0; i < formelements.length; i++)
    {
      var elem = formelements[i];

      if(elem.nodeName.toLowerCase() == "label") continue;   // ARRR! I wish these weren't included...
      index++;

      array[index] = elem.name;

      makeARow(treechildren, [index, "", elem.name, elem.type, (elem.value != undefined) ? elem.value : ((elem.checked == true) ? thebundle.getString("formChecked") : thebundle.getString("formUnchecked"))]);
    }

    var page = window.opener.frames[0].document;
    var labels = page.getElementsByTagName("label");
    for (var i = 0; i < labels.length; i++)
    {
      var j = 0;
      var index = 0;
      var whatfor = labels[i].getAttribute("for");

      while(j < array.length && whatfor != array[j])
      {
        j++;    // heh, that just looks _wrong_... ;)
      }

      treechildren.childNodes[j-1].firstChild.childNodes[1].setAttribute("label", labels[i].firstChild.data)
    }
  }
}

//******** Link Stuff
function makeLinkTab()
{
  var start = new Date();
  var linktree = document.getElementById("linktree");
  var linktreechildren = document.getElementById("linktreechildren");

  if(linktreechildren.firstChild)
  {
    dump("Page Info - Link Tab already filled in, skiping.\n");
    return;
  }

  linklist = grabAllLinks(thecontent);

  if (linklist.length > 0)
  {
    for (var i = 0; i < linklist.length; i++)
    {
      var elem = linklist[i];
      switch (elem.nodeName.toLowerCase())
      {
        case "a":
          if (!(linktext = getValueText(elem)))
            linktext = getAltText(elem);
          makeARow(linktreechildren, [++linkindex, linktext, elem.href, thebundle.getString("linkAnchor")]);
          break;
        case "area":
          makeARow(linktreechildren, [++linkindex, elem.alt, elem.href, thebundle.getString("linkArea")]);
          break;
        case "input":
          makeARow(linktreechildren, [++linkindex, elem.value || thebundle.getString("linkSubmit"), elem.form.action, thebundle.getString("linkSubmission")]);
          break;
        case "link":
          if (elem.rel)
            var linktext = "link rel: " + elem.rel;
          else
            var linktext = "link rev: " + elem.rev;
          makeARow(linktreechildren, [linkindex++, elem.name, elem.href, linktext]);
          break;
        default:
          dump("Page Info - makeLinkTab(): Hey, that's an odd one! ("+elem+")");
          break;
      }
    }
  }

  var end = new Date();
  dump("Page Info - Link Tab Construction - Rows Created: "+linklist.length+", Elapsed Time: "+(end - start)+"ms\n");
}

function grabAllLinks(thecontent)
{
  if (thecontent.frames.length > 0)
  {
    var thelist = [];
    for (var i = 0; i < thecontent.frames.length; i++)
    {
      concatAA(thelist, grabAllLinks(thecontent.frames[i]));
    }
  }
  else
  {
    var page = thecontent.document;

    var thelist = page.links;
    thelist = concatAA(thelist, page.getElementsByTagName("link"));
    var inputlist = page.getElementsByTagName("input");
    for (var i = 0; i < inputlist.length; i++)
      if (inputlist[i].type.toLowerCase() == "submit")
        thelist = concatAS(thelist, inputlist[i]);
  }
  
  return thelist;
}

function openURL(target)
{
  var url = target.parentNode.childNodes[2].value;
  window.open(url, "_blank", "chrome");
}

//******** Image Stuff
function makeMediaTab()
{
  var start = new Date();
  var imagetreechildren = document.getElementById("imagetreechildren");

  if(imagetreechildren.firstChild)
  {
    dump("Page Info - Media Tab already filled in, skiping.\n");
    return;
  }

  imagelist = grabAllMedia(thecontent);

  if (imagelist.length > 0)
  {
    for (var i = 0; i < imagelist.length; i++)
    {
      var elem = imagelist[i];

      switch (elem.nodeName.toLowerCase())
      {
        case "img":
          makeARow(imagetreechildren, [++imageindex, elem.src, elem.name, thebundle.getString("imageImg")]);
          break;
        case "applet":
          makeARow(imagetreechildren, [++imageindex, elem.src, elem.name, thebundle.getString("imageApplet")]);
          break;
        case "object":
          makeARow(imagetreechildren, [++imageindex, elem.src, elem.name, thebundle.getString("imageObject")]);
          break;
        case "script":
          makeARow(imagetreechildren, [++imageindex, elem.src || thebundle.getString("imageLocalScript"), elem.id, elem.type]);
          break;
        case "embed":
          makeARow(imagetreechildren, [++imageindex, elem.src, elem.name, thebundle.getString("imageEmbed")]);
          break;
        default:
          dump("Page Info - makeMediaTab(): hey, that's an odd one! ("+elem+")");;
          break;
      }
    }
  }

  var end = new Date();
  dump("Page Info - Media Tab Construction - Rows Created: "+imagelist.length+", Elapsed Time: "+(end - start)+"ms\n");
}

function grabAllMedia(thecontent)
{
  if (thecontent.frames.length > 0)
  {
    var thelist = [];
    for (var i = 0; i < thecontent.frames.length; i++)
    {
      concatAA(thelist, grabAllMedia(thecontent.frames[i]));
//dump("frame\n");
    }
  }
  else
  {
//dump("window\n");
    var page = thecontent.document;
    var thelist = page.images;
    thelist = concatAA(thelist, page.applets);
    thelist = concatAA(thelist, page.getElementsByTagName("object"));
    thelist = concatAA(thelist, page.getElementsByTagName("script"));
    thelist = concatAA(thelist, page.getElementsByTagName("embed"));
  }
  
  return thelist;
}  

function onImageSelect()
{
  var tree = document.getElementById("imagetree");
  var preview = document.getElementById("imagepreview");

  if (tree.selectedItems.length == 1)
  {
    var clickedRow = tree.selectedItems[0].firstChild;
    var linenum = clickedRow.childNodes[0].getAttribute("label");
    var imageUrl = clickedRow.childNodes[1].getAttribute("label");

    preview.setAttribute("url", imageUrl);
    preview.setAttribute("linenum", linenum);
    preview.removeAttribute("src");
    preview.src = "chrome://navigator/content/imagePreview.xul";
//    preview.makePreview();
//    preview.refresh();
  }
  else
  {
    preview.removeAttribute("src");
  }
}

//******** Other Misc Stuff
// concatenate two arrays
// I need this function because DOM HTMLCollections don't have a concat function of their own, like javascript arrays
function concatAA(arry1, arry2)
{
  var index = 0;
  
  var outarray = new Array(arry1.length+arry2.length);

  for (var i = 0; i < arry1.length; i++)
    outarray[index++] = arry1[i];
  for (var i = 0; i < arry2.length; i++)
    outarray[index++] = arry2[i];
  
  return outarray;
}

// concatenate an array and a 'scalar'
// I need this function because DOM HTMLCollections don't have a concat function of their own, like javascript arrays
function concatAS(arry, sclr)
{
  var index = 0;
  var outarray = new Array(arry.length+1);  
 
  for (var i = 0; i < arry.length; i++)
    outarray[index++] = arry[i];
  outarray[index] = sclr;
  return outarray;
} 

// Copied from the Links Panel v2.3, http://segment7.net/mozilla/links/links.html
// parse a node to extract the contents of the node
function getValueText(linkNode)
{
  var valueText = "";
  
  for (var texti = 0; texti < linkNode.childNodes.length; texti++)
  {
    var nodeType = linkNode.childNodes[texti].nodeType;
    if (nodeType == Node.TEXT_NODE) // a text node
      valueText += linkNode.childNodes[texti].nodeValue;
    else if (nodeType == Node.ELEMENT_NODE) // an element node
      valueText += getValueText(linkNode.childNodes[texti]);
  }

  return valueText;
}

// Copied from the Links Panel v2.3, http://segment7.net/mozilla/links/links.html
// traverse the tree in search of an img or area element and grab its alt tag
function getAltText(node)
{
  var altText = "";
  
  if (node.alt)
    return node.alt;
  if (node.title)
    return node.title;
  for (var alti = 0; alti < node.childNodes.length; alti++)
    if ((altText = getAltText(node.childNodes[alti]) != undefined))  // stupid js warning...
      return altText;
  return "";
}

// this function is the most expensive one we've got. typically eats 99% of the execution time, unless I miss my guess..
function makeARow(parent, array)
{
  var treeitem = document.createElement("treeitem");
  var treerow = treeitem.appendChild(document.createElement("treerow"));

  for (var i = 0; i < array.length; i++)
  {
    var treecell = treerow.appendChild(document.createElement("treecell"));
    treecell.setAttribute("label", array[i]);
  }

  return parent.appendChild(treeitem);
}